import numpy as np
import re
import pylab as pl
from StringIO import StringIO
import string
import config

def readtlog(fichcsv):
    fv=open(fichcsv,"r")
    fv.readline()
    fv.readline()
    fv.readline()
    l=[]
    for s in fv :
#        print s
        s=string.replace(s,',,',',0,')
        ss=string.replace(s,',,',',0,')
        ll=list(re.split(',',ss))
        lt=map(float,map(ll.__getitem__,[0,3,6]))
        l.append(lt)
    fv.close
    return l

def lvtrg(x30,x90,xaac,n30,n90,naac):
    teta= 30*np.pi/360
    xac=np.take(xaac,naac)
    x3=np.take(x30,n30)
    x9=np.take(x90,n90)
    n3=len(x3)
    n9=len(x9)
    
    n3aac=[]; t3aac=[]; x3aac=[]
    n9aac=[]; t9aac=[]; x9aac=[]
    for i in range(n3) :
        if naac.__contains__(n30[i]-2) and naac.__contains__(n30[i]+1):
            n3aac.append(i)
            t3aac.append(4*teta*i)
            x3aac.append(x30[n30[i]])
    for i in range(n9):
        if naac.__contains__(n90[i]-1) and naac.__contains__(n90[i]+2):
            n9aac.append(i)
            t9aac.append(4*teta*i)
            x9aac.append(x90[n90[i]])    
#    x3aac=np.take(x30,n3aac)
#    x9aac=np.take(x90,n9aac)    
    tx3=np.arange(n3)*teta*4
    tx9=np.arange(n9)*teta*4

    if n30[0]<n90[0]:
        tx9=tx9+3*teta
        t9aac=np.array(t9aac)+3*teta
    else :
        tx3=tx3+teta
        t3aac=np.array(t3aac)+teta
    return tx3,x3,tx9,x9,t3aac,x3aac,t9aac,x9aac
    
def histtlog(t30,d30,t90,d90):
    n36=int(np.floor(len(t30)/6)-1)
    nr36=np.arange(0,n36*6,6)
    n96=int(np.floor(len(t90)/6)-1)
    nr96=np.arange(0,n96*6,6)
    h30=[];h90=[]
    for i in range(6):
        x=np.take(d30,nr36+i)
        h30.append(np.sum(x))
    for i in range(6):
        y=np.take(d90,nr96+i)
        h90.append(np.sum(y))    
    return np.array(h30)/len(nr36),np.array(h90)/len(nr96)
        
def vtrg(l) :
    n=l[:,0].size
    rpm= 60.*1000/360.
    i =0
    x30=np.zeros(n)
    n30=[]
    x90=np.zeros(n)
    n90=[]
    xaac=np.zeros(n)
    naac=[]
    while i<n-1 :
        while l[i,1] < 0.01 :
            xaac[i]=rpm*720./l[i,2]
            naac.append(i)
            i=i+1
            if i == n-1 :
                return lvtrg(x30,x90,xaac,n30,n90,naac)
        j=i+1
        while l[j,1] <0.01 :
            xaac[j]=rpm*720./l[j,2]
            naac.append(j)
            j=j+1
            if j == n :
                return lvtrg(x30,x90,xaac,n30,n90,naac)
        if l[i,1]>l[j,1] :
            x90[i]=rpm*90./l[i,1]
            n90.append(i)
            x30[j]=rpm*30./l[j,1]
            n30.append(j)
#            print "l90i 3l0j",i,l[i,1],j,l[j,1]
#            print "x90i x30j",i,x90[i],j,x30[j]
        else :
            x90[j]=rpm*90./l[j,1]
            n90.append(j)
            x30[i]=rpm*30./l[i,1]
            n30.append(i)
#            print "l90j 3l0i",j,l[j,1],i,l[i,1]
#            print "x90j x30i",j,x90[j],i,x30[i]
        i=j+1
#    print x30,x90
    return lvtrg(x30,x90,xaac,n30,n90,naac)

def vtrg2(x) :
    if x<config.a2 and x>0.01:
        return 120./x
    if x>config.a2 :
        config.a2=x/2.
        return 600./x
    return x
    
def plottlog(fichcsv):
    config.a1 =40
    config.a2=150
    lt=np.array(readtlog(fichcsv))
    ns=lt[:,0]
    trg1=lt[:,1]
    trg2=lt[:,2]
    pl.plot(ns,trg1,ns,trg2)
    pl.show()
    pl.close()
    ltx=vtrg(lt)
    tx30,x30,tx90,x90,t30aac,x30aac,t90aac,x90aac=ltx
#    pl.plot(tx30,x30,'rx',tx90,x90,'gx')
    pl.plot(tx30,x30,'rx',tx90,0*x90,'gx',t30aac,x30aac,'ro',
        t90aac,x90aac,'go')
#    pl.plot(ns,trg30,'rx',ns,trg90,'gx')
    pl.ylabel("trg30(rx) trg90(gx) trgaac(bo)")
    pl.show()
    pl.close()
    dx30=-np.append(0,np.ediff1d(x30))
    dx90=-np.append(0,np.ediff1d(x90))
    dltx=tx30,dx30,tx90,dx90

    t0=list(tx30).index(t30aac[0])
    tm=len(tx30)
    while True :
        pl.plot(tx30[t0:tm],0*dx30[t0:tm],'rx',tx90[t0:tm],dx90[t0:tm],'gx',t30aac[t0:tm],np.array(x30aac[t0:tm]),'ro',t90aac[t0:tm],0*np.array(x90aac[t0:tm]),'go')
#    pl.plot(ns,trg30,'rx',ns,trg90,'gx')
        pl.ylabel("trg30(rx) trg90(gx) trgaac(bo) (rpm)")
        pl.show()
        pl.close()
        ds30,ds90=histtlog(tx30[t0:tm],dx30[t0:tm],tx90[t0:tm],dx90[t0:tm])
        pl.plot(tx30[0:6],0*ds30,'ro',tx90[0:6],ds90,'go')
#    pl.plot(np.ediff1d(vit1),'g+')
#    pl.hist(ns,weights=trg1)
        pl.show()
        pl.close()
        cs30=[]
        cs90=[]
        for i in range(3) :
            cs30.append((ds30[i]+ds30[i+3])/2)
            cs90.append((ds90[i]+ds90[i+3])/2)
        pl.plot(tx30[0:3],0*cs30,'ro',tx90[0:3],cs90,'go')
#    pl.plot(np.ediff1d(vit1),'g+')
#    pl.hist(ns,weights=trg1)
        pl.show()
        pl.close()
        tx0=input("min histo : ")
        if tx0 < 0 :
            break         
        txm=input("max histo : ")
        t0=0
        while tx30[t0] < tx0 :
            t0=t0+1
        tm=0
        while tx30[tm] < txm :
            tm=tm+1
    return trg1

def readvlog(fichcsv):
    fv=open(fichcsv,"r")
    fv.readline()                                   # #Vems
    lvar=re.split('\t',fv.readline())       # liste des variables
    dat=np.loadtxt(fv)      #array[0] est la 1er ligne du log
    fv.close
    return lvar,dat

def plotvlog(fichcsv,var1,var2) :
    lvar,dat=readvlog(fichcsv)
    ndat=dat[:,0].size
#    print ndat
    nvar1=lvar.index(var1)
    nvar2=lvar.index(var2)
    print nvar1, nvar2
    t=dat[0:ndat-1,0]
    x=dat[0:ndat-1,nvar1]
    y=dat[0:ndat-1,nvar2]
    print x
    pl.plot(x,y)
    pl.xlabel(var1)
    pl.ylabel(var2)
#    pl.ylimit(0,7000)
    pl.show()
    pl.close()
    pl.plot(x)
    pl.ylabel(var1)
    pl.xlabel('Samples')
#    pl.ylimit(0,7000)
    pl.show()
    pl.close()
# nbr de tours entre 2 echantillons
    dt =np.ediff1d(t)
    spl=np.arange(0,ndat-2,1)
#    pl.plot(spl,x[0:ndat-2]/100.,spl,np.ediff1d(x),spl,10*np.ediff1d(y))
    pl.plot(spl,np.ediff1d(x),spl,10*np.ediff1d(y))
    pl.ylabel('d'+var1+' '+'10d'+var2)
    pl.xlabel('Sample')
    pl.show()
    pl.close()
    pl.plot(np.ediff1d(x),np.ediff1d(y))
    pl.xlabel('d'+var1)
    pl.ylabel('d'+var2)
    pl.show()
    pl.close()
#    pl.plot(np.ediff1d(dat[0:ndat-1,0]))
#    pl.show()
#    pl.close()
    return dat[0:ndat-1,nvar1],np.ediff1d(dat[0:ndat-1,nvar1])

def plotvlogfrq(fichcsv,var) :
    lvar,dat=readvlog(fichcsv)
    ndat=dat[:,0].size -1
#    print ndat
    nvar=lvar.index(var)
    t=dat[0:ndat,0]
    y=dat[0:ndat,nvar]
    dy=np.ediff1d(y)
#    yz=np.append(y,np.zeros(2*ndat))
    yz=np.append(dy,np.zeros(2*ndat))
    d=0.047         #timestep
    frq=np.abs(np.fft.fftfreq(yz.size,d))
    yf=np.fft.fft(yz)
    yfp=np.sqrt(yf.real**2+yf.imag**2) #power
    pl.plot(frq,yfp)
    pl.xlabel('Frequency (Hz)')
    pl.ylabel(var)
    pl.show()
    pl.close()
    return

